var cmp06400aprovacao_desaprovacao_solicitacao_comprasController = function(General, ScreenService, templateManager, ZhFilterPreferences, Utilities, $http, MessageService) {
	//messages to display
	var mensagens = {
		widgetIsNotValid: 'Preencha todos os campos corretamente.',
		errorInGridAction: 'Ocorreu um erro durante o processo. A operação foi cancelada.',
		cancelGridAction: 'A operação foi cancelada.'
	};

	var self = this;
	
	function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }

	this.setFilterInitValues = function(widget) {
		var filterRow = {
	
			CDOPERADOR: getLocalVar('CDOPERADOR'),
			STATUS: ["S", "N", "R"],
			IDOPERACAO: "R",
		};
		ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
	};
	
	this.setRelatorio = function(args) {
		var stripe = args.owner.container.getWidget('stripe');
		args.e.metadata.filter = [
			{"label": ScreenService.i18n("Solicitações"), "value": stripe.currentRow.SOLICITACAO},
            {"label": ScreenService.i18n("Status"), "value": stripe.currentRow.STATUS},    
            {"label": ScreenService.i18n("Tipo de Custo"), "value": stripe.currentRow.TIPOCUSTO}, 
            {"label": ScreenService.i18n("Agrupamento"), "value": stripe.currentRow.AGRUPAMENTO}, 
            {"label": ScreenService.i18n("Dt. Entrega"), "value": stripe.currentRow.DTENTREGASTRIPE},         
            {"label": ScreenService.i18n("Dt. Solicitação"), "value": stripe.currentRow.DTSOLICSTRIPE}
		];
	};
	
	this.widgetOnEnter = function() {
		var cdtipocusto;
		var nmtipocusto;
		let filterRowConcat = {};
		let filterRowPadrao = {};
		let filterRowRedirecionamento = {};
		
		const widget = templateManager.container.getWidget('cmp06400aprovacao_desaprovacao_grid');
		
		General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/cmp06400_verificaTipoCusto', 'Row', widget.currentRow).then(function(callback) {
		 	var tipocusto = callback.dataset.res[0];
		 	if(tipocusto.length == 0) {
				cdtipocusto = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO; 
				nmtipocusto = widget.getField('NMTIPOCUSTO').dataSource.data[0].NMTIPOCUSTO; 
		 	}else {
		 		cdtipocusto = tipocusto[0].CDTIPOCUSTO;
		 		nmtipocusto = tipocusto[0].NMTIPOCUSTO;
		 	}
		 	
		 	filterRowPadrao = {
				"CDOPERADOR": getLocalVar('CDOPERADOR'),
				"STATUS": ["S", "N", "R"],
				"CDTIPOCUSTO": cdtipocusto,
				"NMTIPOCUSTO": nmtipocusto
			};
		 	
		 	if(!Util.isEmptyOrBlank(widget.externParams)) {
		 		const idOperacao = widget.externParams.IDOPERACAO == "R" ? "R" : "A";
		 		const cdFilial = widget.externParams.CDFILSOLI ? widget.externParams.CDFILSOLI : "";
		 		const nrSoliCmp = widget.externParams.NRSOLICMP ? widget.externParams.NRSOLICMP : "";
		 		
		 		filterRowRedirecionamento = {
					"IDOPERACAO": idOperacao,
					"CDFILIAL": [cdFilial],
					"NRSOLICMP": [nrSoliCmp]
				};
		 	}
		 	
		 	filterRowConcat = Object.assign({}, filterRowPadrao, filterRowRedirecionamento);
		 	
			Utilities.startFilter(widget, filterRowConcat).then(function () {
				if(!Util.isEmptyOrBlank(widget.externParams)) {
					let fieldCdfilial = widget.getField('CDFILIAL');
					let fieldNrsolicmp = widget.fields.filter(field => field.name == 'NRSOLICMP' && field.template == 'field/select-multiple.html')[0];
					
					setValueSelectMultipleFields(fieldNrsolicmp, fieldCdfilial, widget.externParams);
					
					fieldCdfilial.reload();
					fieldNrsolicmp.reload();
				}
			});
    	});
	};
	
	function setValueSelectMultipleFields(fieldNrsolicmp, fieldCdfilial, externValues) {
		fieldCdfilial.dataSourceFilter = [
			{
				"name": "CDGRUPFILI",
				"operator": "=",
				"value": "T"
			},
			{
				"name": "CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "CDFILIAL",
				"operator": "IN",
				"value": [externValues.CDFILSOLI]
			}
		];
		
		fieldNrsolicmp.dataSourceFilter = [
			{
				"name": "P_CDFILSOLI",
				"operator": "=",
				"value": externValues.CDFILSOLI
			},
			{
				"name": "P_CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "P_CDAGRUPFILI",
				"operator": "=",
				"value": null
			},
			{
				"name": "NRSOLICMP",
				"operator": "IN",
				"value": [externValues.NRSOLICMP]
			}
		];
	}

	this.setStripe = function(widget) {
		var status = '';
	
		var filterRow = widget.appliedFilter.FILTER_ROW;
		var stripe = widget.container.getWidget('stripe');
		for (var i = 0; i < filterRow.STATUS.length; i++) {
		  if(filterRow.STATUS[i] == 'S') status = status + ' Extra ';
    	  if(filterRow.STATUS[i] == 'N') status = status + '- Não Extra';
    	  if(filterRow.STATUS[i] == 'R') status = status + '- Ruptura';
		}
		stripe.currentRow.SOLICITACAO = filterRow.IDOPERACAO === 'A' ? 'Aprovadas' : 'Desaprovadas';
		stripe.currentRow.STATUS = status;
		stripe.currentRow.TIPOCUSTO = filterRow.NMTIPOCUSTO;
		stripe.currentRow.DTENTREGASTRIPE = filterRow.DTENTREGA.start ? "Data de Entrega: " + filterRow.DTENTREGA.start + " à " + filterRow.DTENTREGA.end : "";
		stripe.currentRow.DTSOLICSTRIPE =  filterRow.DTSOLICITACAO.start ? "Data de Solicitação: " + filterRow.DTSOLICITACAO.start + " à " + filterRow.DTSOLICITACAO.end : "";
		stripe.currentRow.AGRUPAMENTO =  filterRow.NMGRUPFILI ? "Agrupamento de Unidades: " + filterRow.NMGRUPFILI : "";
		
		if(!Util.isEmptyOrBlank(widget.externParams)) {
			widget.getAction('VOLTAR_TELA').isVisible = true;
		}
		
		widget._filterInfo = [
            {"label": "Solicitações", "value": stripe.currentRow.SOLICITACAO},
            {"label": "Status", "value": stripe.currentRow.STATUS},    
            {"label": "Tipo de Custo", "value": stripe.currentRow.TIPOCUSTO},                 
            {"label": "Dt. Entrega", "value": stripe.currentRow.DTENTREGASTRIPE},         
            {"label": "Dt. Solicitação", "value": stripe.currentRow.DTSOLICSTRIPE}
        ];
        
		widget.reload().then(function(success) {
			templateManager.container.getWidget('cmp06400aprovacao_desaprovacao_grid').activate();
		});
	};
	
	this.filtrar = function(args) {
		var widget = args.owner;
		var filterRow = args.e.preference.FILTER_ROW;

		if (typeof(filterRow) === 'object') {
			var actionGrid = widget.getAction('GRID_ACTION');
			actionGrid.label = (filterRow.IDOPERACAO) === 'R' ? "Aprovar" : "Desaprovar";
			actionGrid.icon = (filterRow.IDOPERACAO === 'R') ? "checked" : "error";

			widget.getField('QTSOLIPROD').isVisible  = filterRow.IDOPERACAO === 'R';
			widget.getField('DSJUSTOPER').isVisible  = filterRow.IDOPERACAO === 'R';
			widget.getField('TXOBSITMSOL').isVisible = filterRow.IDOPERACAO === 'R';

			var idsolextra = filterRow.STATUS.filter(function(status) {
				return status !== 'R';
			});
			
			var CDFILIAL    = filterRow.CDFILIAL   ? Array.isArray(filterRow.CDFILIAL)   && filterRow.CDFILIAL.length   > 0 ? filterRow.CDFILIAL.join('_')   : null : null;
			var NRSOLICMP   = filterRow.NRSOLICMP  ? Array.isArray(filterRow.NRSOLICMP)  && filterRow.NRSOLICMP.length  > 0 ? filterRow.NRSOLICMP.join('_')  : null : null;
			var CDCOMPRADOR = (!filterRow.CDCOMPRADOR) ? null : filterRow.CDCOMPRADOR;
			var CDGRUPFILI  = filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : null;
			var CDOPERADOR  = getLocalVar('CDOPERADOR');
			
			args.e.preference.CUSTOM_FILTER_ROW = {
			    "P_CDFILIAL"    : CDFILIAL,
			    "P_TCDFILIAL"   : CDFILIAL ? null : 'T',
			    "T_CDFILIAL"    : CDFILIAL ? null : 'T',
			    "P_CDGRUPFILI"  : CDGRUPFILI,
			    "P_DTENTRINI"   : filterRow.DTENTREGA ? filterRow.DTENTREGA.start : null,
			    "P_DTENTRFIM"   : filterRow.DTENTREGA ? filterRow.DTENTREGA.end   : null,
			    "P_TENTREGA"    : filterRow.DTENTREGA && filterRow.DTENTREGA.start && filterRow.DTENTREGA.end ? null : 'T',
			    "P_NRSOLICMP"   : NRSOLICMP,
			    "P_TNRSOLICMP"  : NRSOLICMP ? null : 'T',
			    "P_DTSOLINI"    : filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.start : null,
			    "P_DTSOLFIM"    : filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.end   : null,
			    "P_TSOLICITA"   : filterRow.DTSOLICITACAO && filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end ? null : 'T',
			    "P_CDOPERADOR"  : CDOPERADOR,
			    "P_IDSOLEXTRA"  : idsolextra.join(''),
			    "P_IDSOLRUPTURA": filterRow.STATUS.indexOf('R') > -1 ? 'S' : null,
			    "P_CDCOMPRADOR" : CDCOMPRADOR,
			    "P_TCDCOMPRADOR": CDCOMPRADOR ? null : 'T',
			    "P_IDOPERACAO"  : filterRow.IDOPERACAO,
			    "P_NRTIPOCUSTO":  filterRow.CDTIPOCUSTO
			};
			
			widget.dataSourceFilter = [
			   { "name": "P_CDFILIAL"    , 'operator':'=', 'value': CDFILIAL },
			   { "name": "P_TCDFILIAL"   , 'operator':'=', 'value': CDFILIAL ? null : 'T' },
			   { "name": "T_CDFILIAL"    , 'operator':'=', 'value': CDFILIAL ? null : 'T' },
			   { "name": "P_CDGRUPFILI"  , 'operator':'=', 'value': CDGRUPFILI },
			   { "name": "P_DTENTRINI"   , 'operator':'=', 'value': filterRow.DTENTREGA ? filterRow.DTENTREGA.start : null },
			   { "name": "P_DTENTRFIM"   , 'operator':'=', 'value': filterRow.DTENTREGA ? filterRow.DTENTREGA.end   : null },
			   { "name": "P_TENTREGA"    , 'operator':'=', 'value': filterRow.DTENTREGA && filterRow.DTENTREGA.start && filterRow.DTENTREGA.end ? null : 'T' },
			   { "name": "P_NRSOLICMP"   , 'operator':'=', 'value': NRSOLICMP },
			   { "name": "P_TNRSOLICMP"  , 'operator':'=', 'value': NRSOLICMP ? null : 'T' },
			   { "name": "P_DTSOLINI"    , 'operator':'=', 'value': filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.start : null },
			   { "name": "P_DTSOLFIM"    , 'operator':'=', 'value': filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.end   : null },
			   { "name": "P_TSOLICITA"   , 'operator':'=', 'value': filterRow.DTSOLICITACAO && filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end ? null : 'T' },
			   { "name": "P_CDOPERADOR"  , 'operator':'=', 'value': CDOPERADOR },
			   { "name": "P_IDSOLEXTRA"  , 'operator':'=', 'value': idsolextra.join('') },
			   { "name": "P_IDSOLRUPTURA", 'operator':'=', 'value': filterRow.STATUS.indexOf('R') > -1 ? 'S' : null },
			   { "name": "P_CDCOMPRADOR" , 'operator':'=', 'value': CDCOMPRADOR },
			   { "name": "P_TCDCOMPRADOR", 'operator':'=', 'value': CDCOMPRADOR ? null : 'T' },
			   { "name": "P_IDOPERACAO"  , 'operator':'=', 'value': filterRow.IDOPERACAO },
			   { "name": "P_NRTIPOCUSTO" , 'operator':'=', 'value': filterRow.CDTIPOCUSTO }
			];
		}
	};

	//create filter for 'Unidades Solicitantes' fields
	this.createDsFilterUS = function(field) {
		field.dataSourceFilter = [{
			'name': 'CDOPERADOR',
			'operator': '=',
			'value': getLocalVar('CDOPERADOR')
		}, {
			'name': 'CDGRUPFILI',
			'operator': '=',
			'value': field.widget.currentRow.CDGRUPFILI
		}];
		field.reload();
	};

	//create filter for 'Solicitação' field
	this.createDsFilter = function(field) {
		
		if (!field.widget.currentRow.CDFILIAL) {
			field.widget.currentRow.T_NMFILIAL = 'T';
		}
		else {
			field.widget.currentRow.T_NMFILIAL = "L";
		}
		
		if(field.widget.getField('IDOPERACAO').value() == 'A') {
			field.dataSource.name = "cmp_solicitacao_solicitacaoCompras#/crud/solicita_itemsoli_params_aprov";
		}
		else {
			field.dataSource.name = "cmp_solicitacao_solicitacaoCompras#/crud/solicita_itemsoli_params";
		}
	
		var cdfilial = field.widget.currentRow.CDFILIAL ? field.widget.currentRow.CDFILIAL.join('_') : null;
		field.dataSourceFilter = [
			{
				'name': 'P_CDAGRUPFILI',
				'operator': '=',
				'value': field.widget.currentRow.CDGRUPFILI ? field.widget.currentRow.CDGRUPFILI : null
			}, 
			{
				'name': 'P_CDFILSOLI',
				'operator': '=',
				'value': field.widget.currentRow.CDFILIAL ? cdfilial : 'T'
			}, 
			{
				'name': 'P_CDOPERADOR',
				'operator': 'IN',
				'value': getLocalVar('CDOPERADOR')
			}
		];
		field.reload();
	};


	//grid action 'Aprova/Reprova Itens'
	this.aprovaReprovaItens = function(widget) {
		var rows = widget.getCheckedRows();
		var rowsToSave = [];
		rows.forEach(function(row) {
			var rowToSave = {};
			rowToSave.CDFILSOLI = row.CDFILSOLI;
			rowToSave.CDFILLAN = row.CDFILLAN;
			rowToSave.NRSOLICMP = row.NRSOLICMP;
			rowToSave.CDPRODUTO = row.CDPRODUTO;
			rowToSave.DTPROGENTR = moment(row.DTPROGENTR, "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY");
			rowToSave.__is_new = false;
			rowToSave.changed = true;
			
			if (widget.getAction('GRID_ACTION').icon === 'error') {
				rowToSave.IDSOLIAPROV = 'N';
				rowToSave.DTHRAPROVSOL = null;
				rowToSave.CDOPERAPROV = null;
			} else {
				rowToSave.IDSOLIAPROV = 'S';
				rowToSave.DTHRAPROVSOL = moment().format('DD/MM/YYYY HH:mm:ss');
				rowToSave.CDOPERAPROV = getLocalVar("CDOPERADOR");
			}
			
			rowsToSave.push(rowToSave);
		});
		
		General.callRestEngine('cmp#/crud/itemsoli/save', 'DataSet', rowsToSave).then(function(success) {
			var msg = {};
			msg.idstatus = widget.getAction('GRID_ACTION').icon === 'error' ? 'desaprovado' : 'aprovado';
			msg.numrows = rowsToSave.length.toString();
			
			if (rowsToSave.length > 1) {
				MessageService.successNotificationByCode("ITENS_SUCCESS_INSERT", { "NUMROWS": msg.numrows, "IDSTATUS": msg.idstatus });
			} else {
				MessageService.successNotificationByCode("ITEM_SUCCESS_INSERT", { "IDSTATUS": msg.idstatus });
			}
			
			widget.unSelectAll();
			widget.reload().then(success => {
				//self.openTelaLancamento();
			});
		}, function(err) {
			ScreenService.notificationMessage(mensagens.errorInGridAction, 'error');
		});
	};
	//clear dependent fields on filter
	this.clearFields = function(field) {
		var widget = field.widget;
		if (field.name === 'NMGRUPFILI') {
			widget.getField('CDFILIAL').clearValue();
		}
		else if (field.name === 'NMFILIAL') {
			widget.getField('CDFILIAL').clearValue();
		}
	};

	//confirm grid action
	this.confirmGridAction = function(widget) {
		var msg = {};
		msg.idstatus = widget.getAction('GRID_ACTION').icon === 'error' ? 'desaprovar' : 'aprovar';
		msg.numrows = widget.getCheckedRows().length.toString();
		
		if (widget.getCheckedRows().length > 1) {
			msg.line = 'Deseja ' + msg.idstatus + ' os ' + msg.numrows + ' itens selecionados?';
		} else {
			msg.line = 'Deseja ' + msg.idstatus + ' o item selecionado?';
		}
		ScreenService.confirmMessage(ScreenService.i18n(msg.line), 'question', function(success) {
			self.aprovaReprovaItens(widget);
		}, function(error) {});
	};

	this.enableGrid = function() {
		var grid = templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid");
		grid.activate();
	};
	
	this.setFilterInfo = function() {
		var grid = templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid");
		var stripe = templateManager.container.getWidget("stripe");
		grid._filterInfo = [
			{
				"label": "Solicitações",
				"value": stripe.currentRow.SOLICITACAO
			}
		];
	};
	
	this.openTelaLancamento = function(widget) {
        ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#/cmp03100_lancamento_de_solicitacao_de_compras').then(function() {
            // let widRetorno = templateManager.container.getActiveWidget();
            // widRetorno.externalRow = widget.externParams;
            // Utilities.startFilter(widRetorno, widRetorno.externalRow);
        });
        
		// $http.get('assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/json/containers/cmp03100_lancamento_de_solicitacao_de_compras.json').then(function(result) {
		// 	var containerAprovacaoDesaprovacao = this.containerFactory(result.data);
		// 	const filtro = templateManager.container.getWidget('dadosSolicitacao').currentRow;
		// 	templateManager.container = containerAprovacaoDesaprovacao;
		// 	onEnterAprovacaoDesaprovacao(templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid"), filtro);
		// }.bind(metaDataFactory), function(error) {
		// 	throw error;
		// });
    };

};

Configuration(function(ContextRegister) {
	ContextRegister.register('cmp06400aprovacao_desaprovacao_solicitacao_comprasController', cmp06400aprovacao_desaprovacao_solicitacao_comprasController);
});
